]> git.ipfire.org Git - thirdparty/gcc.git/blame - contrib/gcc_update
Remove an invalid defintion [PR101568].
[thirdparty/gcc.git] / contrib / gcc_update
CommitLineData
f717c7e4
GP
1#! /bin/sh
2#
97075d3b
RO
3# Update a local Subversion, Git or Mercurial tree from the GCC
4# repository, with an emphasis on treating generated files correctly, so
5# that autoconf, gperf et al are not required for the ``end'' user.
f717c7e4 6#
b2bcb1b3
GP
7# (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8# 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9# Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
1b9f940b
DB
10#
11# This script is Free Software, and it can be copied, distributed and
12# modified as defined in the GNU General Public License. A copy of
13# its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14#
15#
97075d3b
RO
16# By default all command-line options are passed to `svn update` or `hg/git
17# pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
9b14b81c 18# reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
12acf3a9
AJ
19# are omitted.
20#
9d59f307
GP
21# If the first parameter reads --patch, the second parameter is considered
22# a patch file.
12acf3a9 23#
1b9f940b 24# If the first parameter is --touch, no svn operation will be performed,
94b82f2b
AO
25# only generated files that appear to be out of date in the local tree
26# will be touched.
27#
28# If the first parameter is --list, a list of the generated files and
29# their dependencies will be printed; --help prints this message.
30#
2d072788
ZW
31# If the first parameter is --silent, this script prints nothing other
32# than error messages; the second parameter is then interpreted as above.
33#
9b14b81c
GP
34# Examples:
35#
1b9f940b 36# contrib/gcc_update -r 8712
b9550bfb
GP
37# contrib/gcc_update --patch some-patch
38# contrib/gcc_update --touch
39# contrib/gcc_update --list
23a05d03 40
f717c7e4 41
97075d3b 42# Default options used when updating (none).
1b9f940b 43UPDATE_OPTIONS=""
6cf735a7 44
c334c130
BS
45# Set the locale to C to make this script work for users with foreign
46# locale like e.g. French UTF-8.
47LANG=C
48LC_ALL=C
49export LANG LC_ALL
50
6cf735a7 51######## Anything below shouldn't be changed by regular users.
f717c7e4 52
fda73e41
AO
53# Arrange for the value of $0 to be available for functions
54self=$0
f717c7e4 55
2d072788
ZW
56# This function prints its arguments to standard output unless
57# "silent" is set.
7e3c8f17 58unset silent
2d072788
ZW
59chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
62 fi
63}
64
94b82f2b
AO
65# This function prints a list of all generated files, along with their
66# dependencies. Note that only one target is supported per line: the
67# colon is stripped from the output.
68files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
71b5d516
PB
70# fixincludes
71fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
6eb95e99
ZW
73# intl library
74intl/plural.c: intl/plural.y
437eea66 75intl/plural-config.h: intl/plural.y
61c3ff8f
AP
76intl/configure: intl/configure.ac intl/aclocal.m4
77intl/config.h.in: intl/configure.ac intl/aclocal.m4
94b82f2b 78# Now, proceed to gcc automatically generated files
c5d1156b
AP
79gcc/configure: gcc/configure.ac
80gcc/cstamp-h.in: gcc/configure.ac
1a618a5a 81gcc/config.in: gcc/cstamp-h.in
94b82f2b 82gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
37f14a0d 83gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
a92ffb3e
RE
84gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
85gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
bcead286
BS
86gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
47c94d21 89gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
d371df6f 90gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
f10d3ac9 91gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
05c93a63 92gcc/config/rs6000/fusion.md: gcc/config/rs6000/genfusion.pl
dd552284
WL
93gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94b82f2b 95# And then, language-specific files
029d882c 96gcc/cp/cfns.h: gcc/cp/cfns.gperf
e4048ffc
JT
97# testsuite
98# Without this, _Pragma3.c can have a false negative.
99gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
6d409e8a
HPN
100# Similarly, without this, you will see:
101# direct2s.c:35: warning: current file is older than direct2.c
102gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
d7f09764
DN
103# lto-plugin
104lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
105lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
09616422
NS
106# tools
107c++tools/configure: c++tools/configure.ac
108c++tools/config.h.in: c++tools/configure.ac
94b82f2b 109# And libraries, at last
9e953fed 110libbanshee/configure: libbanshee/configure.ac
5a4f1818 111libmudflap/configure: libmudflap/configure.ac
3adc31d1 112libobjc/configure: libobjc/configure.ac
5b03e555
KC
113zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
114zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
115zlib/configure: zlib/configure.ac zlib/aclocal.m4
a4b0b8f1
KC
116fastjar/aclocal.m4: fastjar/configure.ac
117fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
118fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
9a399055 119boehm-gc/aclocal.m4: boehm-gc/configure.ac
cc605afe 120boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
bf9a420e 121boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
4f5b645a 122libada/configure: libada/configure.ac
7de53bca
AT
123libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
124libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
125libffi/configure: libffi/configure.ac libffi/aclocal.m4
126libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
dbfa8d15
AJ
127libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
128libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
36a41ef1
TB
129libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
130libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
131libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
dbfa8d15 132libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
3d5e3eb4 133libcody/configure: libcody/configure.ac libcody/config.m4
d5ad6feb 134libcpp/aclocal.m4: libcpp/configure.ac
5b292a4b 135libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
d5ad6feb 136libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
953ff289 137libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
41dbbb37 138libgomp/Makefile.am: libgomp/plugin/Makefrag.am
953ff289 139libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
cd13be9b 140libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
41dbbb37 141libgomp/configure.ac: libgomp/plugin/configfrag.ac
953ff289
DN
142libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
143libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
0a35513e
AH
144libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
145libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
146libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
147libitm/configure: libitm/configure.ac libitm/aclocal.m4
148libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
48310492
RH
149libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
150libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
151libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
152libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
153libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
451a210d 154libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
6671a4e4
L
155libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
156libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
451a210d
L
157libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
158libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
159libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
2077db1b
CT
160libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
161libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
162libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
4ed8ef26
IV
163liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
164liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
165liboffloadmic/configure: liboffloadmic/configure.ac
166liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
167liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
168liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
22381c22
TS
169libbacktrace/aclocal.m4: libbacktrace/configure.ac
170libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
171libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
172libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
357044d2
RO
173libphobos/Makefile.in: libphobos/Makefile.am libphobos/configure.ac libphobos/aclocal.m4
174libphobos/aclocal.m4: libphobos/configure.ac libphobos/acinclude.m4
175libphobos/config.h.in: libphobos/configure.ac libphobos/aclocal.m4
176libphobos/configure: libphobos/configure.ac libphobos/aclocal.m4
177libphobos/src/Makefile.in: libphobos/src/Makefile.am libphobos/aclocal.m4
178libphobos/testsuite/Makefile.in: libphobos/testsuite/Makefile.am libphobos/aclocal.m4
95ddd785
NN
179# Top level
180Makefile.in: Makefile.tpl Makefile.def
61930fe5 181configure: configure.ac config/acx.m4
94b82f2b
AO
182EOF
183}
184
185
9d59f307
GP
186# This function touches generated files such that the ``end'' user does
187# not have to rebuild them.
94b82f2b 188touch_files () {
e8b073c1
AO
189 rm -f Makefile.$$
190 echo 'all: \' > Makefile.$$
191 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
192 echo '; @true' >> Makefile.$$
193 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
194 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
195 echo ':' >> Makefile.$$
29a948c8 196 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
e8b073c1 197 echo ' echo Touching $@...; \' >> Makefile.$$
2d072788 198 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
e8b073c1
AO
199 echo ' touch $@' >> Makefile.$$
200 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
18ccc7e0 201
9eaf7da0 202 # We would have to explicitly shut off the "Entering... Leaving..."
18ccc7e0
HPN
203 # messages through "--no-print-directory" to handle the case when
204 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
205 # Makefile, not just make). Passing only "-s" doesn't help then,
206 # because make has helpfully added "-w" to MAKEFLAGS automatically.
9eaf7da0
HPN
207 # Unfortunately we do not require GNU make other than for building
208 # and testing, so let's just grep known text explicitly echoed by
209 # the rule.
210 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
e8b073c1
AO
211 sleep 1
212 done 2>&1
213 rm -f Makefile.$$
9d59f307
GP
214}
215
e8b073c1 216
25a9b3e5
AO
217# Whenever we update the tree or install a patch, we may be modifying
218# this script. By re-execing it, we ensure that the appropriate
219# dependencies and rules will be used.
220touch_files_reexec () {
2d072788
ZW
221 chat "Adjusting file timestamps"
222 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
12acf3a9 223}
9d59f307
GP
224
225# This functions applies a patch to an existing tree.
94b82f2b 226apply_patch () {
d028e149 227 if [ -f "$1" ]; then
9d59f307 228 echo "Applying patch file $1"
d028e149 229 case $1 in
9d59f307 230 *gz)
d028e149 231 gzip -d -c "$1" | patch -p1 ;;
5c96cc3b 232 *bz2)
d028e149 233 bzip2 -d -c "$1" | patch -p1 ;;
9d59f307 234 *)
d028e149 235 patch -p1 < "$1";;
9d59f307
GP
236 esac
237 fi
25a9b3e5 238 touch_files_reexec
9d59f307
GP
239}
240
9d59f307 241# Check whether this indeed looks like a local tree.
933c5149 242if [ ! -f gcc/reload.c ]; then
b9550bfb 243 echo "This does not seem to be a GCC tree!"
9d59f307 244 exit
f717c7e4
GP
245fi
246
2d072788
ZW
247case "$1" in
248--silent)
249 silent=t
250 shift
251 ;;
252esac
253
94b82f2b 254case "$1" in
9d59f307 255# First of all, check whether we are going to process a patch.
12acf3a9 256--patch)
94b82f2b
AO
257 if test "$#" != 2; then
258 echo "$1" expects only one argument >&2
259 exit 1
260 fi
261 apply_patch "${2}"
262 exit $?
263 ;;
264
265--touch)
266 if test "$#" != 1; then
267 echo "$1" does not expect any argument >&2
268 exit 1
269 fi
270 touch_files
271 exit $?
272 ;;
273
274--list)
275 if test "$#" != 1; then
276 echo "$1" does not expect any argument >&2
277 exit 1
278 fi
279 files_and_dependencies | sed 's/ /: /'
280 exit $?
281 ;;
282
283--help)
284 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
285\
286
287p
288}' \
289 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
290 exit $?
291 ;;
292
293esac
9d59f307 294
97075d3b 295# Check for known version control systems.
254f7933 296if [ -d .git ] || [ -f .git ]; then
e31a6dc2 297 GCC_GIT=${GCC_GIT-${GIT-git}}
97075d3b
RO
298 vcs_type="git"
299elif [ -d .hg ]; then
300 GCC_HG=${GCC_HG-${HG-hg}}
301 vcs_type="hg"
302elif [ -d .svn ]; then
303 GCC_SVN=${GCC_SVN-${SVN-svn}}
304 vcs_type="svn"
305else
306 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
9d59f307
GP
307 exit
308fi
9b14b81c 309
9d59f307 310# Check command-line options
9b14b81c
GP
311if [ x"${1}"x = x"--nostdflags"x ]; then
312 shift
313else
314 set -- $UPDATE_OPTIONS ${1+"$@"}
315fi
316
97075d3b
RO
317case $vcs_type in
318 git)
319 chat "Updating GIT tree"
2d072788 320
97075d3b
RO
321 $GCC_GIT diff --quiet --exit-code HEAD
322 if [ $? -ne 0 ]; then
323 echo "Attempting to update a dirty git tree!" >&2
324 echo "Commit or stash your changes first and retry." >&2
325 exit 1
326 fi
f717c7e4 327
97075d3b
RO
328 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
329 if [ $? -ne 0 ]; then
330 (touch_files_reexec)
331 echo "git pull of full tree failed." >&2
332 exit 1
333 fi
36dcf055 334
f17f6127 335 revision=`$GCC_GIT log -n1 --pretty=tformat:%p:%t:%H`
97075d3b
RO
336 branch=`$GCC_GIT name-rev --name-only HEAD || :`
337 ;;
338
339 hg)
340 chat "Updating HG tree"
341
342 # Add -q so untracked files aren't listed.
343 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
344 echo "Attempting to update a dirty hg tree!" >&2
345 echo "Commit or revert your changes first and retry." >&2
346 exit 1
347 fi
348
349 # Check for mq extension. mq patches must be popped so tip has
350 # been converted from the SVN tree.
351 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
352 # FIXME: Perhaps pop queue instead? We could do that since we
353 # know the tree is clean.
354 echo "Attempting to update hg tree with mq patches applied!" >&2
355 echo "Pop your patches first and retry." >&2
356 exit 1
357 fi
358
359 # Update tree, but make sure to only pull the default branch.
360 # Otherwise all branches in the upstream repo are added, even if
361 # only a single one has been cloned.
6832435e 362 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
97075d3b
RO
363 if [ $? -ne 0 ]; then
364 (touch_files_reexec)
365 echo "hg pull of full tree failed." >&2
366 exit 1
367 fi
368
6832435e
RO
369 # Update tree. Needs to be done separately from pull so
370 # gcc_update -rREV works.
371 $GCC_HG update ${silent+-q} ${1+"$@"}
372 if [ $? -ne 0 ]; then
373 (touch_files_reexec)
374 echo "hg update of full tree failed." >&2
375 exit 1
376 fi
377
378 # Extract SVN revision corresponding to parents, as stored by
379 # hg convert. Before hg 1.4.3, there's no template keyword
380 # corresponding to the extra: tag, so need to use hg log --debug
381 # to extract the info.
382 parents=`$GCC_HG parents --template '{rev}'`
39b75e51 383 convert_revision=`$GCC_HG log --debug -r$parents | \
97075d3b 384 sed -ne "/^extra:.*convert_revision=svn:/ {
39b75e51 385 s%^[^/]*/%%
97075d3b
RO
386 p
387 }"`
39b75e51
RO
388 revision=`echo $convert_revision | sed -e 's/.*@//'`
389 branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
97075d3b
RO
390 ;;
391
392 svn)
393 chat "Updating SVN tree"
394
395 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
396 if [ $? -ne 0 ]; then
397 (touch_files_reexec)
398 echo "SVN update of full tree failed." >&2
399 exit 1
400 fi
401
c75e90f3 402 revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
6e39ee0c 403 branch=`$GCC_SVN info | sed -ne "/^URL:/ {
97075d3b
RO
404 s,.*/trunk,trunk,
405 s,.*/branches/,,
406 s,.*/tags/,,
407 p
408 }"`
409 ;;
410esac
411
412rm -f LAST_UPDATED gcc/REVISION
2a08c780 413{
97075d3b
RO
414 date
415 echo "`TZ=UTC date` (revision $revision)"
2a08c780 416} > LAST_UPDATED
36dcf055
L
417echo "[$branch revision $revision]" > gcc/REVISION
418
25a9b3e5 419touch_files_reexec